Index: dll/shellext/shellbtrfs/balance.h
===================================================================
--- dll/shellext/shellbtrfs/balance.h	(nonexistent)
+++ dll/shellext/shellbtrfs/balance.h	(copie de travail)
@@ -0,0 +1,58 @@
+/* Copyright (c) Mark Harmstone 2016-17
+ *
+ * This file is part of WinBtrfs.
+ *
+ * WinBtrfs is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public Licence as published by
+ * the Free Software Foundation, either version 3 of the Licence, or
+ * (at your option) any later version.
+ *
+ * WinBtrfs is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public Licence for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public Licence
+ * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
+
+#include <windows.h>
+#ifndef __REACTOS__
+#include "../btrfsioctl.h"
+#else
+#include "btrfsioctl.h"
+#endif
+
+class BtrfsBalance {
+public:
+    BtrfsBalance(WCHAR* drive, BOOL RemoveDevice = FALSE, BOOL ShrinkDevice = FALSE) {
+        removing = FALSE;
+        devices = NULL;
+        called_from_RemoveDevice = RemoveDevice;
+        called_from_ShrinkDevice = ShrinkDevice;
+        wcscpy(fn, drive);
+    }
+
+    void ShowBalance(HWND hwndDlg);
+    INT_PTR CALLBACK BalanceDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
+    INT_PTR CALLBACK BalanceOptsDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
+
+private:
+    void ShowBalanceOptions(HWND hwndDlg, UINT8 type);
+    void SaveBalanceOpts(HWND hwndDlg);
+    void StartBalance(HWND hwndDlg);
+    void RefreshBalanceDlg(HWND hwndDlg, BOOL first);
+    void PauseBalance(HWND hwndDlg);
+    void StopBalance(HWND hwndDlg);
+
+    UINT32 balance_status;
+    btrfs_balance_opts data_opts, metadata_opts, system_opts;
+    UINT8 opts_type;
+    btrfs_query_balance bqb;
+    BOOL cancelling;
+    BOOL removing;
+    BOOL shrinking;
+    WCHAR fn[MAX_PATH];
+    btrfs_device* devices;
+    BOOL readonly;
+    BOOL called_from_RemoveDevice, called_from_ShrinkDevice;
+};

Modification de propriétés sur dll/shellext/shellbtrfs/balance.h
___________________________________________________________________
Added: svn:eol-style
## -0,0 +1 ##
+native
\ No newline at end of property
Index: dll/shellext/shellbtrfs/contextmenu.cpp
===================================================================
--- dll/shellext/shellbtrfs/contextmenu.cpp	(révision 75772)
+++ dll/shellext/shellbtrfs/contextmenu.cpp	(copie de travail)
@@ -1,22 +1,28 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
 #ifndef __REACTOS__
+#define UNICODE
+#endif
+#include "shellext.h"
+#ifndef __REACTOS__
 #include <windows.h>
+#include <strsafe.h>
+#include <stddef.h>
 #include <winternl.h>
 #else
 #define WIN32_NO_STATUS
@@ -23,8 +29,14 @@
 #include <windef.h>
 #include <winbase.h>
 #include <strsafe.h>
+#include <shellapi.h>
+#include <winioctl.h>
 #include <ndk/iofuncs.h>
+#undef DeleteFile
 #endif
+#include <wincodec.h>
+#include <string>
+#include <sstream>
 
 #define NO_SHLWAPI_STRFCNS
 #include <shlwapi.h>
@@ -34,7 +46,7 @@
 #ifndef __REACTOS__
 #include "../btrfsioctl.h"
 #else
-#include "../../drivers/filesystems/btrfs/btrfsioctl.h"
+#include "btrfsioctl.h"
 #endif
 
 #define NEW_SUBVOL_VERBA "newsubvol"
@@ -41,38 +53,28 @@
 #define NEW_SUBVOL_VERBW L"newsubvol"
 #define SNAPSHOT_VERBA "snapshot"
 #define SNAPSHOT_VERBW L"snapshot"
+#define REFLINK_VERBA "reflink"
+#define REFLINK_VERBW L"reflink"
+#define RECV_VERBA "recvsubvol"
+#define RECV_VERBW L"recvsubvol"
+#define SEND_VERBA "sendsubvol"
+#define SEND_VERBW L"sendsubvol"
 
-#ifndef __REACTOS__
-// FIXME - is there a way to link to the proper header files without breaking everything?
-#ifdef __cplusplus
-extern "C" {
-#endif
-NTSYSCALLAPI NTSTATUS NTAPI NtFsControlFile(HANDLE FileHandle, HANDLE Event, PIO_APC_ROUTINE ApcRoutine, PVOID ApcContext, PIO_STATUS_BLOCK IoStatusBlock, ULONG FsControlCode, PVOID InputBuffer, ULONG InputBufferLength, PVOID OutputBuffer, ULONG OutputBufferLength);
-#ifdef __cplusplus
-}
-#endif
+typedef struct {
+    ULONG  ReparseTag;
+    USHORT ReparseDataLength;
+    USHORT Reserved;
+} reparse_header;
 
-#define STATUS_SUCCESS          (NTSTATUS)0x00000000
-#endif
-
-typedef struct _KEY_NAME_INFORMATION {
-    ULONG NameLength;
-    WCHAR Name[1];
-} KEY_NAME_INFORMATION;
-
-typedef ULONG (WINAPI *_RtlNtStatusToDosError)(NTSTATUS Status);
-
-extern HMODULE module;
-
 // FIXME - don't assume subvol's top inode is 0x100
 
 HRESULT __stdcall BtrfsContextMenu::QueryInterface(REFIID riid, void **ppObj) {
     if (riid == IID_IUnknown || riid == IID_IContextMenu) {
-        *ppObj = static_cast<IContextMenu*>(this); 
+        *ppObj = static_cast<IContextMenu*>(this);
         AddRef();
         return S_OK;
     } else if (riid == IID_IShellExtInit) {
-        *ppObj = static_cast<IShellExtInit*>(this); 
+        *ppObj = static_cast<IShellExtInit*>(this);
         AddRef();
         return S_OK;
     }
@@ -86,160 +88,339 @@
     IO_STATUS_BLOCK iosb;
     btrfs_get_file_ids bgfi;
     NTSTATUS Status;
-    
+
     if (!pidlFolder) {
         FORMATETC format = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
         UINT num_files, i;
         WCHAR fn[MAX_PATH];
         HDROP hdrop;
-        
+
         if (!pdtobj)
             return E_FAIL;
-        
+
         stgm.tymed = TYMED_HGLOBAL;
-        
+
         if (FAILED(pdtobj->GetData(&format, &stgm)))
             return E_INVALIDARG;
-        
+
         stgm_set = TRUE;
-        
+
         hdrop = (HDROP)GlobalLock(stgm.hGlobal);
-        
+
         if (!hdrop) {
             ReleaseStgMedium(&stgm);
             stgm_set = FALSE;
             return E_INVALIDARG;
         }
-         
+
         num_files = DragQueryFileW((HDROP)stgm.hGlobal, 0xFFFFFFFF, NULL, 0);
-        
+
         for (i = 0; i < num_files; i++) {
-            if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(MAX_PATH))) {
+            if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(WCHAR))) {
                 h = CreateFileW(fn, FILE_TRAVERSE, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
-    
+
                 if (h != INVALID_HANDLE_VALUE) {
                     Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_FILE_IDS, NULL, 0, &bgfi, sizeof(btrfs_get_file_ids));
-                        
-                    if (Status == STATUS_SUCCESS && bgfi.inode == 0x100 && !bgfi.top) {
+
+                    if (NT_SUCCESS(Status) && bgfi.inode == 0x100 && !bgfi.top) {
                         WCHAR parpath[MAX_PATH];
                         HANDLE h2;
-                        
+
                         StringCchCopyW(parpath, sizeof(parpath) / sizeof(WCHAR), fn);
-                        
+
                         PathRemoveFileSpecW(parpath);
-                        
+
                         h2 = CreateFileW(parpath, FILE_ADD_SUBDIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
-    
-                        if (h2 == INVALID_HANDLE_VALUE) {
-                            CloseHandle(h);
-                            return E_FAIL;
-                        }
-                        
+
+                        if (h2 != INVALID_HANDLE_VALUE)
+                            allow_snapshot = TRUE;
+
+                        CloseHandle(h2);
+
                         ignore = FALSE;
                         bg = FALSE;
-                        
-                        CloseHandle(h2);
+
                         CloseHandle(h);
+                        GlobalUnlock(hdrop);
                         return S_OK;
                     }
-                    
+
                     CloseHandle(h);
                 }
             }
         }
-        
+
+        GlobalUnlock(hdrop);
+
         return S_OK;
     }
 
     if (!SHGetPathFromIDListW(pidlFolder, path))
         return E_FAIL;
-    
+
     // check we have permissions to create new subdirectory
-    
+
     h = CreateFileW(path, FILE_ADD_SUBDIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
-    
+
     if (h == INVALID_HANDLE_VALUE)
         return E_FAIL;
-    
+
     // check is Btrfs volume
-    
+
     Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_FILE_IDS, NULL, 0, &bgfi, sizeof(btrfs_get_file_ids));
-    
-    if (Status != STATUS_SUCCESS) {
+
+    if (!NT_SUCCESS(Status)) {
         CloseHandle(h);
         return E_FAIL;
     }
-    
+
     CloseHandle(h);
-    
+
     ignore = FALSE;
     bg = TRUE;
-    
+
     return S_OK;
 }
 
+static BOOL get_volume_path_parent(const WCHAR* fn, WCHAR* volpath, ULONG volpathlen) {
+    WCHAR *f, *p;
+    BOOL b;
+
+    f = PathFindFileNameW(fn);
+
+    if (f == fn)
+        return GetVolumePathNameW(fn, volpath, volpathlen);
+
+    p = (WCHAR*)malloc((f - fn + 1) * sizeof(WCHAR));
+    memcpy(p, fn, (f - fn) * sizeof(WCHAR));
+    p[f - fn] = 0;
+
+    b = GetVolumePathNameW(p, volpath, volpathlen);
+
+    free(p);
+
+    return b;
+}
+
+static BOOL show_reflink_paste(WCHAR* path) {
+    HDROP hdrop;
+    HANDLE lh;
+    ULONG num_files;
+    WCHAR fn[MAX_PATH], volpath1[255], volpath2[255];
+
+    if (!IsClipboardFormatAvailable(CF_HDROP))
+        return FALSE;
+
+    if (!GetVolumePathNameW(path, volpath1, sizeof(volpath1) / sizeof(WCHAR)))
+        return FALSE;
+
+    if (!OpenClipboard(NULL))
+        return FALSE;
+
+    hdrop = (HDROP)GetClipboardData(CF_HDROP);
+
+    if (!hdrop) {
+        CloseClipboard();
+        return FALSE;
+    }
+
+    lh = GlobalLock(hdrop);
+
+    if (!lh) {
+        CloseClipboard();
+        return FALSE;
+    }
+
+    num_files = DragQueryFileW(hdrop, 0xFFFFFFFF, NULL, 0);
+
+    if (num_files == 0) {
+        GlobalUnlock(lh);
+        CloseClipboard();
+        return FALSE;
+    }
+
+    if (!DragQueryFileW(hdrop, 0, fn, sizeof(fn) / sizeof(WCHAR))) {
+        GlobalUnlock(lh);
+        CloseClipboard();
+        return FALSE;
+    }
+
+    if (!get_volume_path_parent(fn, volpath2, sizeof(volpath2) / sizeof(WCHAR))) {
+        GlobalUnlock(lh);
+        CloseClipboard();
+        return FALSE;
+    }
+
+    GlobalUnlock(lh);
+
+    CloseClipboard();
+
+    return !wcscmp(volpath1, volpath2);
+}
+
+// The code for putting an icon against a menu item comes from:
+// http://web.archive.org/web/20070208005514/http://shellrevealed.com/blogs/shellblog/archive/2007/02/06/Vista-Style-Menus_2C00_-Part-1-_2D00_-Adding-icons-to-standard-menus.aspx
+
+static void InitBitmapInfo(BITMAPINFO* pbmi, ULONG cbInfo, LONG cx, LONG cy, WORD bpp) {
+    ZeroMemory(pbmi, cbInfo);
+    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
+    pbmi->bmiHeader.biPlanes = 1;
+    pbmi->bmiHeader.biCompression = BI_RGB;
+
+    pbmi->bmiHeader.biWidth = cx;
+    pbmi->bmiHeader.biHeight = cy;
+    pbmi->bmiHeader.biBitCount = bpp;
+}
+
+static HRESULT Create32BitHBITMAP(HDC hdc, const SIZE *psize, void **ppvBits, HBITMAP* phBmp) {
+    BITMAPINFO bmi;
+    HDC hdcUsed;
+
+    *phBmp = NULL;
+
+    InitBitmapInfo(&bmi, sizeof(bmi), psize->cx, psize->cy, 32);
+
+    hdcUsed = hdc ? hdc : GetDC(NULL);
+
+    if (hdcUsed) {
+        *phBmp = CreateDIBSection(hdcUsed, &bmi, DIB_RGB_COLORS, ppvBits, NULL, 0);
+        if (hdc != hdcUsed)
+            ReleaseDC(NULL, hdcUsed);
+    }
+
+    return !*phBmp ? E_OUTOFMEMORY : S_OK;
+}
+
+void BtrfsContextMenu::get_uac_icon() {
+    IWICImagingFactory* factory = NULL;
+    IWICBitmap* bitmap;
+    HRESULT hr;
+
+#ifdef __REACTOS__
+    hr = CoCreateInstance(CLSID_WICImagingFactory, NULL, CLSCTX_INPROC_SERVER, IID_IWICImagingFactory, (void **)&factory);
+#else
+    hr = CoCreateInstance(CLSID_WICImagingFactory, NULL, CLSCTX_INPROC_SERVER, IID_PPV_ARGS(&factory));
+#endif
+
+    if (SUCCEEDED(hr)) {
+        HANDLE icon;
+
+        // We can't use IDI_SHIELD, as that will only give us the full-size icon
+        icon = LoadImageW(GetModuleHandleW(L"user32.dll"), MAKEINTRESOURCEW(106)/* UAC shield */, IMAGE_ICON,
+                          GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), LR_DEFAULTCOLOR);
+
+        hr = factory->CreateBitmapFromHICON((HICON)icon, &bitmap);
+        if (SUCCEEDED(hr)) {
+            UINT cx, cy;
+
+            hr = bitmap->GetSize(&cx, &cy);
+            if (SUCCEEDED(hr)) {
+                SIZE sz;
+                BYTE* buf;
+
+                sz.cx = (int)cx;
+                sz.cy = -(int)cy;
+
+                hr = Create32BitHBITMAP(NULL, &sz, (void**)&buf, &uacicon);
+                if (SUCCEEDED(hr)) {
+                    UINT stride = cx * sizeof(DWORD);
+                    UINT buflen = cy * stride;
+                    bitmap->CopyPixels(NULL, stride, buflen, buf);
+                }
+            }
+
+            bitmap->Release();
+        }
+
+        factory->Release();
+    }
+}
+
 HRESULT __stdcall BtrfsContextMenu::QueryContextMenu(HMENU hmenu, UINT indexMenu, UINT idCmdFirst, UINT idCmdLast, UINT uFlags) {
     WCHAR str[256];
-    
+    ULONG entries = 0;
+
     if (ignore)
         return E_INVALIDARG;
-    
+
     if (uFlags & CMF_DEFAULTONLY)
         return S_OK;
-    
+
     if (!bg) {
-        if (LoadStringW(module, IDS_CREATE_SNAPSHOT, str, sizeof(str) / sizeof(WCHAR)) == 0)
+        if (allow_snapshot) {
+            if (LoadStringW(module, IDS_CREATE_SNAPSHOT, str, sizeof(str) / sizeof(WCHAR)) == 0)
+                return E_FAIL;
+
+            if (!InsertMenuW(hmenu, indexMenu, MF_BYPOSITION, idCmdFirst, str))
+                return E_FAIL;
+
+            entries = 1;
+        }
+
+        if (idCmdFirst + entries <= idCmdLast) {
+            MENUITEMINFOW mii;
+
+            if (LoadStringW(module, IDS_SEND_SUBVOL, str, sizeof(str) / sizeof(WCHAR)) == 0)
+                return E_FAIL;
+
+            if (!uacicon)
+                get_uac_icon();
+
+            memset(&mii, 0, sizeof(MENUITEMINFOW));
+            mii.cbSize = sizeof(MENUITEMINFOW);
+            mii.fMask = MIIM_STRING | MIIM_ID | MIIM_BITMAP;
+            mii.dwTypeData = str;
+            mii.wID = idCmdFirst + entries;
+            mii.hbmpItem = uacicon;
+
+            if (!InsertMenuItemW(hmenu, indexMenu + entries, TRUE, &mii))
+                return E_FAIL;
+
+            entries++;
+        }
+    } else {
+        if (LoadStringW(module, IDS_NEW_SUBVOL, str, sizeof(str) / sizeof(WCHAR)) == 0)
             return E_FAIL;
 
         if (!InsertMenuW(hmenu, indexMenu, MF_BYPOSITION, idCmdFirst, str))
             return E_FAIL;
 
-        return MAKE_HRESULT(SEVERITY_SUCCESS, 0, 1);
-    }
-    
-    if (LoadStringW(module, IDS_NEW_SUBVOL, str, sizeof(str) / sizeof(WCHAR)) == 0)
-        return E_FAIL;
+        entries = 1;
 
-    if (!InsertMenuW(hmenu, indexMenu, MF_BYPOSITION, idCmdFirst, str))
-        return E_FAIL;
+        if (idCmdFirst + 1 <= idCmdLast) {
+            MENUITEMINFOW mii;
 
-    return MAKE_HRESULT(SEVERITY_SUCCESS, 0, 1);
-}
+            if (LoadStringW(module, IDS_RECV_SUBVOL, str, sizeof(str) / sizeof(WCHAR)) == 0)
+                return E_FAIL;
 
-static void ShowError(HWND hwnd, ULONG err) {
-    WCHAR* buf;
-    
-    if (FormatMessageW(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL,
-                       err, 0, (WCHAR*)&buf, 0, NULL) == 0) {
-        MessageBoxW(hwnd, L"FormatMessage failed", L"Error", MB_ICONERROR);
-        return;
+            if (!uacicon)
+                get_uac_icon();
+
+            memset(&mii, 0, sizeof(MENUITEMINFOW));
+            mii.cbSize = sizeof(MENUITEMINFOW);
+            mii.fMask = MIIM_STRING | MIIM_ID | MIIM_BITMAP;
+            mii.dwTypeData = str;
+            mii.wID = idCmdFirst + 1;
+            mii.hbmpItem = uacicon;
+
+            if (!InsertMenuItemW(hmenu, indexMenu + 1, TRUE, &mii))
+                return E_FAIL;
+
+            entries++;
+        }
+
+        if (idCmdFirst + 2 <= idCmdLast && show_reflink_paste(path)) {
+            if (LoadStringW(module, IDS_REFLINK_PASTE, str, sizeof(str) / sizeof(WCHAR)) == 0)
+                return E_FAIL;
+
+            if (!InsertMenuW(hmenu, indexMenu + 2, MF_BYPOSITION, idCmdFirst + 2, str))
+                return E_FAIL;
+
+            entries++;
+        }
     }
-    
-    MessageBoxW(hwnd, buf, L"Error", MB_ICONERROR);
-    
-    LocalFree(buf);
-}
 
-void ShowNtStatusError(HWND hwnd, NTSTATUS Status) {
-    _RtlNtStatusToDosError RtlNtStatusToDosError;
-    HMODULE ntdll = LoadLibraryW(L"ntdll.dll");
-    
-    if (!ntdll) {
-        MessageBoxW(hwnd, L"Error loading ntdll.dll", L"Error", MB_ICONERROR);
-        return;
-    }
-    
-    RtlNtStatusToDosError = (_RtlNtStatusToDosError)GetProcAddress(ntdll, "RtlNtStatusToDosError");
-    
-    if (!ntdll) {
-        MessageBoxW(hwnd, L"Error loading RtlNtStatusToDosError in ntdll.dll", L"Error", MB_ICONERROR);
-        FreeLibrary(ntdll);
-        return;
-    }
-    
-    ShowError(hwnd, RtlNtStatusToDosError(Status));
-    
-    FreeLibrary(ntdll);
+    return MAKE_HRESULT(SEVERITY_SUCCESS, 0, entries);
 }
 
 static void create_snapshot(HWND hwnd, WCHAR* fn) {
@@ -247,13 +428,13 @@
     NTSTATUS Status;
     IO_STATUS_BLOCK iosb;
     btrfs_get_file_ids bgfi;
-    
+
     h = CreateFileW(fn, FILE_TRAVERSE, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
-    
+
     if (h != INVALID_HANDLE_VALUE) {
         Status = NtFsControlFile(h, NULL, NULL, NULL, &iosb, FSCTL_BTRFS_GET_FILE_IDS, NULL, 0, &bgfi, sizeof(btrfs_get_file_ids));
-            
-        if (Status == STATUS_SUCCESS && bgfi.inode == 0x100 && !bgfi.top) {
+
+        if (NT_SUCCESS(Status) && bgfi.inode == 0x100 && !bgfi.top) {
             WCHAR parpath[MAX_PATH], subvolname[MAX_PATH], templ[MAX_PATH], name[MAX_PATH], searchpath[MAX_PATH];
             HANDLE h2, fff;
             btrfs_create_snapshot* bcs;
@@ -260,13 +441,13 @@
             ULONG namelen, pathend;
             WIN32_FIND_DATAW wfd;
             SYSTEMTIME time;
-            
+
             StringCchCopyW(parpath, sizeof(parpath) / sizeof(WCHAR), fn);
             PathRemoveFileSpecW(parpath);
-            
+
             StringCchCopyW(subvolname, sizeof(subvolname) / sizeof(WCHAR), fn);
             PathStripPathW(subvolname);
-            
+
             h2 = CreateFileW(parpath, FILE_ADD_SUBDIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE | FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
 
             if (h2 == INVALID_HANDLE_VALUE) {
@@ -274,7 +455,7 @@
                 CloseHandle(h);
                 return;
             }
-            
+
             if (!LoadStringW(module, IDS_SNAPSHOT_FILENAME, templ, MAX_PATH)) {
                 ShowError(hwnd, GetLastError());
                 CloseHandle(h);
@@ -281,9 +462,9 @@
                 CloseHandle(h2);
                 return;
             }
-            
+
             GetLocalTime(&time);
-            
+
             if (StringCchPrintfW(name, sizeof(name) / sizeof(WCHAR), templ, subvolname, time.wYear, time.wMonth, time.wDay) == STRSAFE_E_INSUFFICIENT_BUFFER) {
                 MessageBoxW(hwnd, L"Filename too long.\n", L"Error", MB_ICONERROR);
                 CloseHandle(h);
@@ -290,21 +471,21 @@
                 CloseHandle(h2);
                 return;
             }
-            
+
             StringCchCopyW(searchpath, sizeof(searchpath) / sizeof(WCHAR), parpath);
             StringCchCatW(searchpath, sizeof(searchpath) / sizeof(WCHAR), L"\\");
             pathend = wcslen(searchpath);
-            
+
             StringCchCatW(searchpath, sizeof(searchpath) / sizeof(WCHAR), name);
-            
+
             fff = FindFirstFileW(searchpath, &wfd);
-            
+
             if (fff != INVALID_HANDLE_VALUE) {
                 ULONG i = wcslen(searchpath), num = 2;
-                
+
                 do {
                     FindClose(fff);
-                    
+
                     searchpath[i] = 0;
                     if (StringCchPrintfW(searchpath, sizeof(searchpath) / sizeof(WCHAR), L"%s (%u)", searchpath, num) == STRSAFE_E_INSUFFICIENT_BUFFER) {
                         MessageBoxW(hwnd, L"Filename too long.\n", L"Error", MB_ICONERROR);
